import QtQuick 2.12
import QtQuick.Window 2.12
import QtQuick.Controls 2.12

Window {
    width: 640
    height: 480
    visible: true
    title: qsTr("Hello World")


    CheckBox {
        id: pixelateCheckbox
        text: "Pixelate"
        checked: true;
    }

    Image {
        source: "qrc:/fit_header.jpg"
        height: parent.height*0.8;
        fillMode: Image.PreserveAspectFit
        id: image
        anchors.centerIn: parent
//        font.pixelSize: 32
        property alias mousePressed: mouse.pressed;
        MouseArea {
            id: mouse;
            anchors.fill: parent

        }
    }

    Timer {
        interval: 1500;
        running: true;
        repeat: true;
        onTriggered: {
            pixelateCheckbox.checked = !pixelateCheckbox.checked;
        }
    }



    ShaderEffect {
        id: shader;
        property variant source: ShaderEffectSource { sourceItem: image; hideSource: true }
        property real dividerValue: 1
        property real targetWidth: image.width
        property real targetHeight: image.height

        anchors.fill: image

        property real granularity: pixelateCheckbox.checked ? 20 : 1
        Behavior on granularity {
            PropertyAnimation { duration: 250 }
        }

        //        property real wiggleAmount: textLabel.mousePressed ? 0.025 : 0.005
        //        Behavior on wiggleAmount {
        //            PropertyAnimation { duration: 150 }
        //        }

//        fragmentShader: "
//             varying highp vec2 qt_TexCoord0;
//             uniform sampler2D source;
//             uniform highp float wiggleAmount;
//             void main(void)
//             {
//                 highp vec2 wiggledTexCoord = qt_TexCoord0;
//                 wiggledTexCoord.s += sin(4.0 * 3.141592653589 * wiggledTexCoord.t) * wiggleAmount;
//                 gl_FragColor = texture2D(source, wiggledTexCoord.st);
//             }
//             "

        fragmentShader: "
uniform float dividerValue;
uniform float granularity;
uniform float targetWidth;
uniform float targetHeight;

uniform sampler2D source;
uniform lowp float qt_Opacity;
varying vec2 qt_TexCoord0;

void main()
{
    vec2 uv = qt_TexCoord0.xy;
    vec2 tc = qt_TexCoord0;
    if (uv.x < dividerValue && granularity > 0.0) {
        float dx = granularity / targetWidth;
        float dy = granularity / targetHeight;
        tc = vec2(dx*(floor(uv.x/dx) + 0.5),
                  dy*(floor(uv.y/dy) + 0.5));
    }
    gl_FragColor = qt_Opacity * texture2D(source, tc);
}

"

    }

}
